/*
* JBoss, Home of Professional Open Source
* Copyright 2005, JBoss Inc., and individual contributors as indicated
* by the @authors tag. See the copyright.txt in the distribution for a
* full listing of individual contributors.
*
* This is free software; you can redistribute it and/or modify it
* under the terms of the GNU Lesser General Public License as
* published by the Free Software Foundation; either version 2.1 of
* the License, or (at your option) any later version.
*
* This software is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
* Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this software; if not, write to the Free
* Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
* 02110-1301 USA, or see the FSF site: http://www.fsf.org.
*/
package org.jboss.antprofilerdemo;

public class Test2 {
    public static void doTest() {
        //System.out.println("doTest");
        String x = new String("");
        System.out.println("String = " + x);
    }

    public void doTest2() {
        try {
            Thread.currentThread().sleep(100);
        } catch (Exception e) {
        }
    }

    public void doTest3() {
        doTest();
        doTest();
        doTest();
        doTest();
        doTest();
        doTest();
        doTest();
        doTest();
        doTest();
        doTest();
    }

    public void doTest4() {
        long goal = System.currentTimeMillis() + 1000;
        while (System.currentTimeMillis() < goal) {
            Thread.currentThread().yield();
        }
    }

    public static void doLargeLoop() {
        for (int i = 0; i < 500; i++)
            doTest();
    }

    static class Test implements Runnable {
        int max;
        public void run() {
              for (int i=0;i<max;i++) {
                  System.out.println("test " + max);
              }
        }
    }

    public static void main(String arg[]) {
        Test1 x = new Test1();
        for (int i = 0; i < 1; i++) {
            System.out.println("i = " + i);
            x.doTest();
            x.doTest2();
            x.doTest3();
            x.doTest4();
            for (int i2=0;i2<1000;i2++) {
                System.out.println("string " + i2);
            }
        }


        for (int i=0;i<10;i++) {
            Test x3 = new Test();
            x3.max = i*10;
            new Thread(x3).start();
        }

        //doLargeLoop();
        System.out.println("End! (If profiler doesn't being terminate soon, wait few seconds and finish by using control-break/del");
    }
}