/*
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 */
package org.jboss.profiler.liteversion.jni;

/**
 * Extracts information from the liteVersion jboss profiler.
 * @author Clebert Suconic
 */
public class LiteVersionController {
    static {
        System.loadLibrary("jbossLiteProfiler");
     }

    public static native void runGC();
    public static native long getCPU();
    public static native long getBytes();
    public static native int getCreatedObjects();
    public static native int getReleasedObjects();

    public static native long getTotalCPU();
    public static native long getTotalBytes();
    public static native int getTotalCreatedObjects();
    public static native int getTotalReleasedObjects();

    
    public static native void saveCurrentInfo();
    public static native String getName();
    
    public static native void activate();
    public static native void deActivate();
    

}
