<%@ include file="rootMenu.inc"%>

<table class="TABELA" >
  <%!
     static class HoldData
     {
        public HoldData(ClassLoader loader, Class clazz)
        {
           this.loader = loader;
           this.clazz = clazz;
        }
        ClassLoader loader;
        Class clazz;
     }
  %>

<%
   verifySession(session,out,true);
   JVMTIInterface jvmti = new JVMTIInterface();
   jvmti.forceGC();
   Collection classes = jvmti.retrieveLoadedClassesByClassName();
   
   ClassLoader systemClassLoaderDummy = new ClassLoader(){public String toString(){return "SystemClassLoader";}};
   boolean printedHeader=false;
   ArrayList classLoaderDuplicates = new ArrayList();
   Iterator iter = classes.iterator();
   String currentName=null;
   Class currentClass = null;
   while (iter.hasNext())
   {
	  	currentClass = (Class)iter.next();
	    if (currentName!=currentClass.getName())
	    {
	       if (classLoaderDuplicates.size()>1)
	       {
	    		    	if (!printedHeader)
	    		    	{
	    		    		out.println("<br><b>List of duplicated classes</b>");
	    		    		printedHeader=true;
	    		    	}

	    				out.println("<br>" + "<b> Class " + currentName +" was loaded on these classLoaders:</b>");
	    				Iterator iterClassLoader = classLoaderDuplicates.iterator();
	    				out.println("<table border=0 valign=up>");
	    				while (iterClassLoader.hasNext())
	    				{
	    				    out.println("<tr valign=up>");
	    				    out.println("<td>");
	    				    HoldData holdData = (HoldData)iterClassLoader.next();
	    					ClassLoader loader = holdData.loader;
	    					out.print("<br>&nbsp;&nbsp;&nbsp;" + loader.getClass().getName() + "@" + System.identityHashCode(loader) );
	    					
	    					long classLoaderTag = jvmti.getTagOnObject(loader);
	    					long classTag = jvmti.getTagOnObject(holdData.clazz);
	    				    out.println("</td>");
	    				    out.println("<td>");
	    					out.print("<a href='./references.jsp?nobjs=1&obj0="+classLoaderTag+"'>Loader References</a>");
	    				    out.println("</td>");
	    				    out.println("<td>");
	    					out.print("<a href='./references.jsp?nobjs=1&obj0="+classTag+"'>Classes References</a>");
	    				    out.println("</td>");
	    				    out.println("</tr>");
	    				}
	    				
	    	}
	    	currentName = currentClass.getName();
	    	classLoaderDuplicates.clear();
	    }

	    ClassLoader loader = currentClass.getClassLoader();
    	if (loader==null)
    	{
    		loader = systemClassLoaderDummy;
    	}
    	classLoaderDuplicates.add(new HoldData(loader,currentClass));
	    		
	    currentName = currentClass.getName();
	}
	%>
	<%
	    	
	if (classLoaderDuplicates.size()>1)
	{
	    				out.println("<br>" + "<b> Class " + currentName +" was loaded on these classLoaders:</b>");
	    				Iterator iterClassLoader = classLoaderDuplicates.iterator();
	    				while (iterClassLoader.hasNext())
	    				{
	    				    out.println("<tr>");
	    				    out.println("<td>");
	    				    HoldData holdData = (HoldData)iterClassLoader.next();
	    					ClassLoader loader = holdData.loader;
	    					out.print("<br>&nbsp;&nbsp;&nbsp;" + loader.getClass().getName() + "@" + System.identityHashCode(loader) );
	    					
	    					long classLoaderTag = jvmti.getTagOnObject(loader);
	    					long classTag = jvmti.getTagOnObject(currentClass);
	    				    out.println("</td>");
	    				    out.println("<td>");
	    					out.print("<a href='./references.jsp?nobjs=1&obj0="+classLoaderTag+"'>Loader References</a>");
	    				    out.println("</td>");
	    				    out.println("<td>");
	    					out.print("<a href='./references.jsp?nobjs=1&obj0="+classTag+"'>Classes References</a>");
	    				    out.println("</td>");
	    				    out.println("</tr>");
	    				}
	}
	    	
%>


</table>