<%@ include file="rootMenu.inc"%>

<% verifySession(session,out,false); %>


<%
   
   JVMTIInterface jvmti = new JVMTIInterface();
   int numberOfObjects = Integer.parseInt(request.getParameter("nobjs"));
   
   StringBuffer baseBuffer = new StringBuffer();
   baseBuffer.append("./references.jsp?nobjs=" + (numberOfObjects+1));
   for (int i=0;i<numberOfObjects;i++)
   {
      baseBuffer.append("&obj" + i + "=" + request.getParameter("obj" + i));
   }
   baseBuffer.append("&obj" + numberOfObjects + "=");
   String baseURL = baseBuffer.toString();
   
   boolean invalid=false;
   long index=0;
   for (int i=0;i<numberOfObjects;i++)
   {
      index = Long.parseLong(request.getParameter("obj" + i));
      Object obj = jvmti.getObjectOnTag(index);
      out.print("<br>");
      for (int j=0;j<i;j++)
      {
         out.println("!---");
      }
      if (obj==null)
      {
         out.println("<b> Reference was gone after processing!</b>");
         invalid=true;
         break;
      }
      else
      {
          if (obj instanceof Class)
          {
	          out.print(obj.toString());
          }
          else
          {
		      out.print(obj.getClass().getName() + "@" + System.identityHashCode(obj));
		  }
	  }
   }
   
   if (!invalid)
   {
      String level = "";
      for (int j=0;j<numberOfObjects;j++)
      {
         level+="!---";
      }
      
      HashMap list = (HashMap)session.getAttribute("list");
      
      Long indexLong = new Long(index);
      ArrayList itemList = (ArrayList)list.get(indexLong);
      
      if (itemList == null)
      {
         itemList = new ArrayList();
      }
      
      if (itemList.size()==0)
      {
          out.println("<br><b>Not references</b>");
      }
      else
      {
          Iterator iterPoint = itemList.iterator();
          int row=0;
          while (iterPoint.hasNext())
          {
              if (row++ > 200)
              {
                 out.println("<br><b>Maximum number of 200 references achieved</b>");
                 break;
              }
              ReferenceDataPoint point = (ReferenceDataPoint)iterPoint.next();
	          jvmti.treatReference(level,new java.io.PrintWriter(out),point,false);
              out.println("&nbsp;<a href='" + baseURL + point.getReferenceHolder() + "'>Detail</a>");
	      }
      }
   
   }
%>