<!-- JSP created by Clebert Rezende Suconic -->

<%@ page import="java.util.*,java.io.*,javax.servlet.http.*, java.beans.*, java.lang.reflect.*, org.jboss.profiler.jvmti.*"%>

<%!

   String declareArray(Object obj) {
   
      if (obj==null) {
         return null;
      } else
      if (obj.getClass().isArray()) {
         Object x[] = (Object[]) obj;
         StringBuffer buffer = new StringBuffer();
         buffer.append("[");
         for (int i=0;i<x.length;i++)
         {
           buffer.append(declareArray(x[i]));
           if (i+1<x.length) 
           {
              buffer.append(",");
           }
         }
         buffer.append("]");
         return buffer.toString();
      } else {
          return obj.toString();
      }
   }
%>

<html>
<body>
   <%
   
   String className = request.getParameter("className");
   
   if (className==null) 
   {%>
   
   Enter the class name
   <form action="./hackClass.jsp">
     <INPUT TYPE="text" name="className" value="">
     <INPUT TYPE="submit" name="ok" value="ok">
   </form>
   
   <%
   }
   else 
   {
           JVMTIInterface jvmti = new JVMTIInterface();
           
           Class classes[] = jvmti.getLoadedClasses();
           
           out.println("<table border=1>");
           Class classfound = null;
           for (int i=0;i<classes.length;i++)
           {
              if (classes[i].getName().equals(className)) 
              {
                 out.println("<tr><td colspan=2><b>Current instances of " + className + " Loader = " + classes[i].getClassLoader() + "</b></td></tr>"); 
                 classfound = classes[i];
                 Field fields[] = jvmti.retrieveAllFields(classfound);
                 
                 out.println("<tr><td>obj.toString()</td>");
                 for (int count=0;count<fields.length;count++)
                 {
                     fields[count].setAccessible(true);
                 }
                 out.println("</tr>");
                 
                 Object obj[] = jvmti.getAllObjects(classfound);
                 
                 
                 %>
                 <%
                   for (int objCount=0;objCount<obj.length;objCount++) {
                       
                       out.print("<tr><td rowspan=" + (fields.length) +">" + obj[objCount].toString() + "</td>");
                       
                       for (int fieldCount=0;fieldCount<fields.length;fieldCount++)
                       {
                          if (fieldCount>0) 
                          {
                             out.println("<tr>");
                          }
                          try {
                                Object result = fields[fieldCount].get(obj[objCount]);
                                out.println("<td nowrap=\"nowrap\"><i>" + fields[fieldCount].getName() + "<i> = " + declareArray(result) + "</td>");
                          }
                          catch (Throwable e) {
                             out.println("<td><b>" + e.toString() + "</b></td>");
                             e.printStackTrace();
                          }
                          out.println("</tr>");
                       }
                       
					   if (objCount>60) {
                          out.println("<tr><td colspan=2><b>Interrupted... there is more objects in the memory</b></td></tr>");
						  break;
                       }
                       
                   }
              }
           }
           
           out.println("</table>");
           
           if (classfound==null)
           {
              out.println("<b> Class " + className + " not found </b>");
           }
   }
   %>
</body>
</html>
