<%@ include file="rootMenu.inc"%>

<%

    String direction = request.getParameter("direction");
    int size = Integer.parseInt(request.getParameter("size"));
    boolean forward = direction.equals("down");

   
    String basicURL = "./references.jsp?size=" + (size+1) + "&direction=" + direction;

    String path[] = new String[size];
    for (int i=0;i<size;i++) {
       path[i] = request.getParameter("path"+i);
       basicURL = basicURL + "&path" + i + "=" + path[i];
    }
    basicURL = basicURL + "&path" + size + "=";

    MemorySnapshotController snapshot = (MemorySnapshotController)session.getAttribute("snapshot");
    Collection references = snapshot.summarizeReferenceByPath(forward,path);
%>
<table class="TABELA" >
   <tr bgcolor="#003366" bordercolor="#666666" style="COLOR:white;">
      <td nowrap="nowrap">Class <%=forward?"Referenced":"Referencer"%></td>
       <td nowrap="nowrap">NumberOfReferences</td>
       <td nowrap="nowrap">NumberOfDistinctObjects</td>
       <td nowrap="nowrap">NumberOfThreadReferences></td>
   </tr>



<%
   Iterator iter = references.iterator();
   int row=0;
   while (iter.hasNext())
   {
     MemoryReferenceSummary reference = (MemoryReferenceSummary)iter.next();

 	 String referenceToSignature = null;
 	 long refId=0;
     if (reference.getReferenceTo()==null)
     {
	     referenceToSignature = "Root";
     }
     else
     {
            referenceToSignature=reference.getReferenceTo().getSignature();
            refId=reference.getReferenceTo().getId();
     }
     
	 if ((row++)%2==0) {
          out.println("<tr bgcolor=white>");
	 } else {
          out.println("<tr bgcolor=\"#cccccc\">");
	 }


     if (refId>0)
     {%>
       <td><%=referenceToSignature%><a href="<%=basicURL + "C" + refId %>"> Detail </a></td>
     <%}
     else
     {%>
       <td><b><%=referenceToSignature%></b></td>
     <%
     }

%>
       <td><%=reference.getNumberOfReferences()%></td>
       <td><%=reference.getNumberOfDistinctObjects()%></td>
       <td><%=reference.getNumberOfThreadReferences()%></td>
    

     </tr>
<%
   }
%>
