<%
/*
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 
 * This file belongs to a simple implementation of a web interface for the "disconnectedProfiler".
*/
%>

<%@ include file="processMenu.inc"%>

<%
 try {
%>
<table class="TABELA" WIDTH="100%">
   <%
      boolean consolidated=false;
      if (request.getParameter("subMethods")!=null) {
         consolidated=true;
      }

      Integer methodId = new Integer(request.getParameter("methodId"));
      JBPMethod keyMethod = new JBPMethod();
      keyMethod.setMethodID(methodId.intValue());

      HashMap JBPMethods = jbpProcess.getSpyMethods();
      JBPMethod JBPMethodProcess = (JBPMethod)JBPMethods.get(keyMethod);

      JBPMethodCount consolidacao = (JBPMethodCount)request.getSession().getAttribute("consolidacaoMetodo");
      if (consolidacao==null || !consolidacao.getSpyMethod().equals(JBPMethodProcess)) {
         consolidacao = jbpProcess.consolidaCallings(JBPMethodProcess);
         request.getSession().setAttribute("consolidacaoMetodo",consolidacao);
         //consolidacao.printDebugCallers(0);
      }


   String urlBasesrc = "methodId="+methodId ; // url para seguir o caminho



   int numberOfPaths=0;
   if (request.getParameter("npath")!=null) {
      numberOfPaths=Integer.parseInt(request.getParameter("npath"));
   }

   int methodsId[] = new int[numberOfPaths];
   JBPMethod metodosPesquisados[] = new JBPMethod[numberOfPaths];
   JBPMethodCount[] consolidacoesPesquisadas = new JBPMethodCount[numberOfPaths];

   String urlBase = "./methodStack.jsp?methodId="+methodId + "&npath="+(numberOfPaths+1); // url para seguir o caminho
   for (int i=0;i<numberOfPaths;i++) {
      methodsId[i] = Integer.parseInt(request.getParameter("m" + i));
      urlBase+="&m"+i+"="+methodsId[i];
      keyMethod.setMethodID(methodsId[i]);
      metodosPesquisados[i]=(JBPMethod)jbpProcess.getSpyMethods().get(keyMethod);
   }
   urlBase+="&m"+numberOfPaths+"=";

   for (int i=0;i<numberOfPaths;i++) {
       consolidacoesPesquisadas[i]=consolidacao.getCalledCount(metodosPesquisados[i]);
       consolidacao = consolidacoesPesquisadas[i];
   }

   JBPMethod methodConsolidado = consolidacao.getSpyMethod();
   methodConsolidado = (JBPMethod)JBPMethods.get(methodConsolidado);

   %>

   <%
     out.println("<tr><td colspan=14 nowrap=\"nowrap\"><img src=\"./imgs/arrow.gif\">"+
        "<a href=\"./methodStack.jsp?" + urlBasesrc +"\">" +
        JBPMethodProcess.getSimplifiedName() + " = 100% calls="+ JBPMethodProcess.getNumberOfCalls()  +" </td>");

    for (int i=0;i<numberOfPaths;i++) {
        String percentCPU="";
         if (JBPMethodProcess.getTotalClock()!=0) {
           percentCPU=numberFormat.format(((double)consolidacoesPesquisadas[i].getTotalClocks()/(double)JBPMethodProcess.getTotalClock())*(double)100);
         }

	 String percentTime="";
         if (JBPMethodProcess.getTotalElapsedClock()!=0) {
           percentTime=numberFormat.format(((double)consolidacoesPesquisadas[i].getTotalElapsedClock()/(double)JBPMethodProcess.getTotalElapsedClock())*(double)100);
         }


      String urlTmp="./methodStack.jsp?" + urlBasesrc +"&npath="+(i+1);
      // estabelece recuperacao da arvore
      for (int j=0;j<=i;j++) {
         urlTmp+="&m"+j+"="+methodsId[j];
      }
      out.print("<tr><td colspan=14 nowra=\"nowrap\">");
      for (int j=0;j<=i;j++) {
        out.print("&nbsp;");
      }
      out.println("<img src=\"./imgs/arrow.gif\">"+
        "<a href=\""+ urlTmp +"\">" +
        metodosPesquisados[i].getSimplifiedName()+" %CPU=" + percentCPU + "&nbsp;%Time=" + percentTime  + " calls="+ consolidacoesPesquisadas[i].getCount() +"</a></td></tr>");
   }

   String strTree="";
   {
     StringBuffer tmp = new StringBuffer();
     for (int i=0;i<numberOfPaths;i++) {
       tmp.append("&nbsp;");
     }
     strTree=tmp.toString();
   }
   %>


   <tr bgcolor="#003366" bordercolor="#666666" style="COLOR:white;">
      <td bgcolor=white bordercolor=white><%=strTree%></td>
      <td>Class Name</td>
      <td>Number of Instances</td>
      <td>Bytes</td>
      <td>Released Instances</td>
      <td>Release Bytes</td>
   </tr>

    <%


      TreeSet setMethods = null;

      // para ordenar pelo maior tempo
      setMethods = new TreeSet(new Comparator() {
                 public int compare (Object o1, Object o2) {
                     JBPMemoryCount s1 = (JBPMemoryCount)o1;
                     JBPGenericCount s2 = (JBPGenericCount)o2;
                     int x = s2.getCount() - s1.getCount();
                     if (x!=0) {
                        return x;
                     } else
                     if ( ((JBPClass)s1.getReferencedObject()).getName()!=null &&
                          ((JBPClass)s2.getReferencedObject()).getName()!=null) {
                         return ((JBPClass)s1.getReferencedObject()).getName().compareTo(((JBPClass)s2.getReferencedObject()).getName());
                     } else {
                         return ((JBPClass)s1.getReferencedObject()).getClassID() - ((JBPClass)s2.getReferencedObject()).getClassID();
                     }
                 }});


      HashMap hashMemory = null;

      if (consolidated) {
         hashMemory = consolidacao.createConsolidatedObjects();
      } else {
         hashMemory = consolidacao.getCountMemory();
      }

      setMethods.addAll(hashMemory.values());

      double totalClock = jbpProcess.getTotalClocks();

      Iterator methodsIterator = setMethods.iterator();
      int line=0;
      while (methodsIterator.hasNext()) {
         JBPMemoryCount JBPGenericCount = (JBPMemoryCount)methodsIterator.next();
         JBPClass JBPClass = (JBPClass)JBPGenericCount.getReferencedObject();
	 if ((line++)%2==0) {
	     out.println("<tr bgcolor=white>");
	 } else {
	     out.println("<tr bgcolor=\"#cccccc\">");
	 }
         out.println("<td bgcolor=white bordercolor=white"+strTree+"</td>");
         out.println("<td>" + JBPClass.getName() + "</td>");
         out.println("<td>" + JBPGenericCount.getCount() + "</td>");
         out.println("<td>" + JBPGenericCount.getSize() + "</td>");
         out.println("<td>" + JBPGenericCount.getCountRelease() + "</td>");
         out.println("<td>" + JBPGenericCount.getReleasedSize() + "</td>");
         out.println("</tr>");
      }
   %>
</table>
</body>
</html>
<%
   }
   catch (Exception e) {
     e.printStackTrace();
   }
%>