<%
/*
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 
 * This file belongs to a simple implementation of a web interface for the "disconnectedProfiler".
*/
%>

<%@ include file="processMenu.inc"%>

<%
 try {
%>
<div align=center>
<table class="TABELA">
   <%
      Integer methodId = new Integer(request.getParameter("methodId"));
      JBPMethod keyMethod = new JBPMethod();
      keyMethod.setMethodID(methodId.intValue());

      HashMap JBPMethods = jbpProcess.getSpyMethods();
      JBPMethod JBPMethod = (JBPMethod)JBPMethods.get(keyMethod);
      out.println("<td colspan=4 bgcolor=\"#003366\" bordercolor=\"#666666\" style=\"COLOR:white;\"> Threads that called method " + JBPMethod.getName() + "(" + JBPMethod.getSignature() + ")");

    %>
   <tr  bgcolor="#003366" bordercolor="#666666" style="COLOR:white;">
      <td>Name</td>
      <td>Clocks for this thread</td>
      <td colspan=2>&nbsp;</td>
   </tr>

    <%
      TreeSet setThreads = null;

      // para ordenar pelo maior tempo
      setThreads = new TreeSet(new Comparator() {
                 public int compare (Object o1, Object o2) {
                     JBPMethodThread s1 = (JBPMethodThread)o1;
                     JBPMethodThread s2 = (JBPMethodThread)o2;
                     int ret = (int)(s2.getSpyMethodOnThread().getTotalClock() -
                               s1.getSpyMethodOnThread().getTotalClock());
                     if (ret!=0) return ret;
                     if ( s1.getSpyMethodOnThread().getName()!=null &&
                         s2.getSpyMethodOnThread().getName()!=null) {
                         return s2.getSpyMethodOnThread().getName().compareTo(s1.getSpyMethodOnThread().getName());
                     } else {
                         return s2.getSpyMethodOnThread().getMethodID() - s1.getSpyMethodOnThread().getMethodID();
                     }
                 }});

      setThreads.addAll(JBPMethod.getThreadList());

      double totalClock = jbpProcess.getTotalClocks();

      Iterator methodsIterator = setThreads.iterator();
      int line=0;
      while (methodsIterator.hasNext()) {
         JBPMethodThread method = (JBPMethodThread)methodsIterator.next();
         JBPThread thread = method.getSpyThread();
           if ((line++)%2==0) {
	     out.println("<tr bgcolor=white>");
           } else {
	     out.println("<tr bgcolor=\"#cccccc\">");
           }
         out.println("<td>" + thread.getName() + " </td>");
         out.println("<td>" + method.getSpyMethod().getTotalClock() + " </td>");
         out.println("<td> <a href=\"./threadMethods.jsp?threadId=" + thread.getThreadId() + "\"> All Methods</a></td>");
         out.println("<td> <a href=\"./threadStackTrace.jsp?threadId=" + thread.getThreadId() + "\"> Stack Trace</a></td>");
         out.println("</tr>");

      }
   %>
</table>
</div>
</body>
</html>
<%
   }
   catch (Exception e) {
     e.printStackTrace();
   }
%>