<%
/*********************************************************************************/
/* The develepment of this program is partly supported by IPA                    */
/* (Information-Technology Promotion Agency, Japan).                             */
/*********************************************************************************/
                                                                                                                 
/*********************************************************************************/
/*  searchConditions.jsp                                                         */
/*  Copyright: Copyright (C) Hitachi, Ltd. 2005                                  */
/*             Author : Yoko SEKI (y-seki@sdl.hitachi.co.jp)                     */
/*  ChangeLog: (Thu Oct 06, 2005) First version release                          */
/*                                                                               */
/*                                                                               */
/*  This library is free software; you can redistribute it and/or                */
/*  modify it under the terms of the GNU Lesser General Public                   */
/*  License as published by the Free Software Foundation; either                 */
/*  version 2.1 of the License, or (at your option) any later version.           */
/*                                                                               */
/*  This library is distributed in the hope that it will be useful,              */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of               */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU            */
/*  Lesser General Public License for more details.                              */
/*                                                                               */
/*  You should have received a copy of the GNU Lesser General Public             */
/*  License along with this library; if not, write to the Free Software          */
/*  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA    */
/*********************************************************************************/
%>

<%@ include file="tracerInternal.inc"%>

<%
   Calendar startCal = Calendar.getInstance();
   startCal.setTimeInMillis((jbpProcess.getDate()).getTime());
   Calendar finishCal = Calendar.getInstance(); 
   finishCal.setTimeInMillis((jbpProcess.getFinishDate()).getTime());
%>

<form action="./allTransactions.jsp" method="POST" target="allTransactions">
   <table align="center" border="2">
      <tr>
         <td><b>start method name</b></td>
         <td><%=startMethod%></td>
      </tr>

      <tr>
         <td><b>transaction type</b></td>
         <td>
             <input type="radio" name="target" value="complete">complete
             <input type="radio" name="target" value="incomplete">incomplete
             <input type="radio" name="target" value="both" checked>both
         </td>
      </tr>
 
      <tr><td colspan="2" align="center">
         <b>search conditions</b></td>
      </tr> 

      <tr>
         <td rowspan="5">transactions</td>

         <td align="left"><input type="checkbox" name="tranStart">
            starting between
            &nbsp;
            <input type="text" name="sMM1"   size="2" maxlength="2" value="<%=startCal.get(Calendar.MONTH)+1    %>">/
            <input type="text" name="sdd1"   size="2" maxlength="2" value="<%=startCal.get(Calendar.DATE)       %>">/
            <input type="text" name="syyyy1" size="4" maxlength="4" value="<%=startCal.get(Calendar.YEAR)       %>">
            &nbsp;
            <input type="text" name="shh1"   size="2" maxlength="2" value="<%=startCal.get(Calendar.HOUR_OF_DAY)%>">:
            <input type="text" name="smm1"   size="2" maxlength="2" value="<%=startCal.get(Calendar.MINUTE)     %>">:
            <input type="text" name="sss1"   size="2" maxlength="2" value="<%=startCal.get(Calendar.SECOND)     %>">.
            <input type="text" name="sSSS1"  size="3" maxlength="3" value="<%=startCal.get(Calendar.MILLISECOND)%>">
            <br>
            <% for (int i=0; i<13; i++) out.println("&nbsp;"); %>
            and&nbsp;
            <input type="text" name="sMM2"   size="2" maxlength="2" value="<%=finishCal.get(Calendar.MONTH)+1    %>">/
            <input type="text" name="sdd2"   size="2" maxlength="2" value="<%=finishCal.get(Calendar.DATE)       %>">/
            <input type="text" name="syyyy2" size="4" maxlength="4" value="<%=finishCal.get(Calendar.YEAR)       %>">
            &nbsp;
            <input type="text" name="shh2"   size="2" maxlength="2" value="<%=finishCal.get(Calendar.HOUR_OF_DAY)%>">:
            <input type="text" name="smm2"   size="2" maxlength="2" value="<%=finishCal.get(Calendar.MINUTE)     %>">:
            <input type="text" name="sss2"   size="2" maxlength="2" value="<%=finishCal.get(Calendar.SECOND)     %>">.
            <input type="text" name="sSSS2"  size="3" maxlength="3" value="<%=finishCal.get(Calendar.MILLISECOND)%>">
         </td>
      </tr>

      <tr>
         <td align="left"><input type="checkbox" name="tranFinish"/>
            finishing between
            &nbsp;
            <input type="text" name="fMM1"   size="2" maxlength="2" value="<%=startCal.get(Calendar.MONTH)+1    %>">/
            <input type="text" name="fdd1"   size="2" maxlength="2" value="<%=startCal.get(Calendar.DATE)       %>">/
            <input type="text" name="fyyyy1" size="4" maxlength="4" value="<%=startCal.get(Calendar.YEAR)       %>">
            &nbsp;
            <input type="text" name="fhh1"   size="2" maxlength="2" value="<%=startCal.get(Calendar.HOUR_OF_DAY)%>">:
            <input type="text" name="fmm1"   size="2" maxlength="2" value="<%=startCal.get(Calendar.MINUTE)     %>">:
            <input type="text" name="fss1"   size="2" maxlength="2" value="<%=startCal.get(Calendar.SECOND)     %>">.
            <input type="text" name="fSSS1"  size="3" maxlength="3" value="<%=startCal.get(Calendar.MILLISECOND)%>">
            <br>
            <% for (int i=0; i<14; i++) out.println("&nbsp;"); %>
            and&nbsp;
            <input type="text" name="fMM2"   size="2" maxlength="2" value="<%=finishCal.get(Calendar.MONTH)+1    %>">/
            <input type="text" name="fdd2"   size="2" maxlength="2" value="<%=finishCal.get(Calendar.DATE)       %>">/
            <input type="text" name="fyyyy2" size="4" maxlength="4" value="<%=finishCal.get(Calendar.YEAR)       %>">
            &nbsp;
            <input type="text" name="fhh2"   size="2" maxlength="2" value="<%=finishCal.get(Calendar.HOUR_OF_DAY)%>">:
            <input type="text" name="fmm2"   size="2" maxlength="2" value="<%=finishCal.get(Calendar.MINUTE)     %>">:
            <input type="text" name="fss2"   size="2" maxlength="2" value="<%=finishCal.get(Calendar.SECOND)     %>">.
            <input type="text" name="fSSS2"  size="3" maxlength="3" value="<%=finishCal.get(Calendar.MILLISECOND)%>">
         </td>
      </tr>

      <tr>
         <td align="left"><input type="checkbox" name="methodInc"/>
            including&nbsp;<input type="text" name="methodIncName" size="40"/>&nbsp;method(s)
            &nbsp;(
            <input type="radio" name="methodIncAndOr" value="and" checked>AND
            <input type="radio" name="methodIncAndOr" value="or">OR)
         </td>
      </tr>

      <tr>
         <td align="left"><input type="checkbox" name="methodExc"/>
            excluding&nbsp;<input type="text" name="methodExcName" size="40"/>&nbsp;method(s)
            &nbsp;(
            <input type="radio" name="methodExcAndOr" value="and" checked>NOR
            <input type="radio" name="methodExcAndOr" value="or">NAND)
         </td>
      </tr>

      <tr>
         <td align="left"><input type="checkbox" name="tranEla"/>
            elapsing more than &nbsp;<input type="text" name="tranTime"/>&nbsp;msec
         </td>
      <tr>

      <tr>
         <td>methods</td>
         <td align="left"><input type="checkbox" name="metEla"/>
            elapsing more than &nbsp;<input type="text" name="metTime"/>&nbsp;msec
         </td>
      <tr>

   </table>
   <input type="hidden" name="searchRun" value="searchRun">
   <center><input type="submit" name="search" value="Submit" class="botaoPadrao"/></center>
</form>
