/*
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 */


#ifndef _DEFINE_THREAD_DATA
#define _DEFINE_THREAD_DATA
class ThreadData {
/** We are keeping everything as public just to minimize overhead */
public:
	ThreadData(JNIEnv *penv_id) {
	    env_id=penv_id;
		allocatedMemory=0;
		usedCPU=0;
		running=1;
	    objectsAllocated=0;
	    objectsReleased=0;

		old_allocatedMemory=0;
		old_objectsAllocated=0;
		old_objectsReleased=0;
		old_usedCPU=0;


	}
	
	JNIEnv *env_id;
	jint allocatedMemory;
	jint objectsAllocated;
	jint objectsReleased;
	jlong usedCPU;
	
	jint old_allocatedMemory;
	jint old_objectsAllocated;
	jint old_objectsReleased;
	jlong old_usedCPU;


	jboolean running;
};


#endif
