
<%
/*
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
*/
%>

<%@ page 
language="java"
contentType="text/html; charset=ISO-8859-1"
pageEncoding="ISO-8859-1"
import="org.jboss.profiler.aop.monitoring.*,org.jboss.profiler.aop.monitoring.model.*,org.jboss.profiler.aop.monitoring.control.*,java.util.*"
%>

<html>
<link rel="stylesheet" type="text/css" href="./imgs/profilerStyles.css">
<body>

<table align=center class="TABELA">
<tr bgcolor="#003366" bordercolor="#666666" style="COLOR:white;">
<td>Pointcut</td>
<td>Number of callings</td>
<td>Max Time</td>
<td>Min Time</td>
<td>Current Thread</td>
<td>Max Threads</td>
<td>Avg Time</td>
<td>Total Time</td>
</tr>


<%
    MeasureAggregation aggregation = MonitoringController.findAggregation(request.getParameter("name"));
    if (aggregation!=null) {
 	   Iterator measures = aggregation.getMeasureSet().iterator();

       int local=0;
 	   while (measures.hasNext()) {
 	       MonitoringMeasure measure = (MonitoringMeasure)measures.next();
 	       TimeValue rootValue = measure.getRootValue();
 	       
	      if ((local++)%2==0) {
			  out.println("<tr bgcolor=white>");
	      } else {
			  out.println("<tr bgcolor=\"#cccccc\">");
	      }
 	       out.println("<td><a href=\"./timeDetail.jsp?name=" + measure.getName() +"\">" + measure.getName() + "</a></td>");
 	       out.println("<td>" + rootValue.getCallings() + "</td>");
 	       out.println("<td>" + rootValue.getMaxTime() + "</td>");
 	       out.println("<td>" + rootValue.getMinTime() + "</td>");
 	       out.println("<td>" + rootValue.getCurrentStack() + "</td>");
 	       out.println("<td>" + rootValue.getMaxStack() + "</td>");
 	       out.println("<td>" + rootValue.getTotalTime()/(rootValue.getCallings()!=0?rootValue.getCallings():1) + "</td>");
 	       out.println("<td>" + rootValue.getTotalTime() + "</td>");
 	       out.println("</tr>");
 	   }
    }
   
%>
</body>
</html>