
<%
/*
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
*/
%>

<%@ page 
language="java"
contentType="text/html; charset=ISO-8859-1"
pageEncoding="ISO-8859-1"
import="org.jboss.profiler.aop.monitoring.*,org.jboss.profiler.aop.monitoring.model.*,org.jboss.profiler.aop.monitoring.control.*,java.util.*"
%>

<html>
<link rel="stylesheet" type="text/css" href="./imgs/profilerStyles.css">
<body>

<table align=center class="TABELA">
<tr bgcolor="#003366" bordercolor="#666666" style="COLOR:white;">
<td colspan=8>Time Detail of <%=request.getParameter("name")%></td>
</tr>
<tr bgcolor="#003366" bordercolor="#666666" style="COLOR:white;">
<td>Date</td>
<td>Number of callings</td>
<td>Max Time</td>
<td>Min Time</td>
<td>Current Thread</td>
<td>Max Threads</td>
<td>Avg Time</td>
<td>Total Time</td>
</tr>


<%
    MonitoringMeasure measure = MonitoringController.findMeasureByName(request.getParameter("name"));
    if (measure!=null) {
 	   Iterator time = new TreeSet(measure.getValues().values()).iterator();

       int local=0;
       java.util.Date date = new java.util.Date();
 	   while (time.hasNext()) {
 	       TimeValue rootValue = (TimeValue)time.next();
 	       
	       if ((local++)%2==0) {
			  out.println("<tr bgcolor=white>");
	       } else {
			  out.println("<tr bgcolor=\"#cccccc\">");
	       }
	       date.setTime(rootValue.getTimeStart());
	       
 	       out.println("<td>" + date.toString() + "</td>");
 	       out.println("<td>" + rootValue.getCallings() + "</td>");
 	       out.println("<td>" + rootValue.getMaxTime() + "</td>");
 	       out.println("<td>" + rootValue.getMinTime() + "</td>");
 	       out.println("<td>" + rootValue.getCurrentStack() + "</td>");
 	       out.println("<td>" + rootValue.getMaxStack() + "</td>");
 	       out.println("<td>" + rootValue.getTotalTime()/(rootValue.getCallings()!=0?rootValue.getCallings():1) + "</td>");
 	       out.println("<td>" + rootValue.getTotalTime() + "</td>");
 	       out.println("</tr>");
 	   }
    }
   
%>
</body>
</html>