/*
* JBoss, Home of Professional Open Source
* Copyright 2005, JBoss Inc., and individual contributors as indicated
* by the @authors tag. See the copyright.txt in the distribution for a
* full listing of individual contributors.
*
* This is free software; you can redistribute it and/or modify it
* under the terms of the GNU Lesser General Public License as
* published by the Free Software Foundation; either version 2.1 of
* the License, or (at your option) any later version.
*
* This software is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
* Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this software; if not, write to the Free
* Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
* 02110-1301 USA, or see the FSF site: http://www.fsf.org.
*/
package org.jboss.profiler.web.form;

import java.util.*;
import org.apache.struts.action.ActionForm;
import org.jboss.profiler.model.*;
import org.jboss.profiler.tracerModel.*;

/**
@author Clebert Suconic
*/
public class FilterForm extends ActionForm {
  private String directory;
  public String getDirectory() {
    return directory;
  }
  public void setDirectory(String directory) {
    this.directory = directory;
  }

  private String selectedPID;

  public void setSelectedPID(String pid) {
     this.selectedPID = pid;
  }

  public String getSelectedPID() {
     return this.selectedPID;
  }


  /** PIDS que estao disponiveis */
  private String [] pids;

  public String[] getPids() {
    return pids;
  }

  public void setPids(String pids[]) {
    this.pids=pids;
  }

  private String message;

  public void setMessage(String message) {
    this.message = message;
  }

  public String getMessage() {
    return message;
  }


  private JBPProcess jbpProcess;

  public void setJbpProcess(JBPProcess spyProcess) {
     this.jbpProcess = spyProcess;
  }

  public JBPProcess getJbpProcess() {
    return this.jbpProcess;
  }

   private String startMethod;
   public String getStartMethod () { return this.startMethod; }
   public void setStartMethod (String startMethod)
   { this.startMethod = startMethod; }

   private HashMap jbtTransactions;
   public HashMap getJbtTransactions () { return this.jbtTransactions; }
   public void setJbtTransactions (HashMap jbtTransactions)
   { this.jbtTransactions = jbtTransactions; }

   private HashMap jbtiTransactions;
   public HashMap getJbtiTransactions () { return this.jbtiTransactions; }
   public void setJbtiTransactions (HashMap jbtiTransactions)
   { this.jbtiTransactions = jbtiTransactions; }

   private HashMap searchedTransactions;
   public HashMap getSearchedTransactions ()
      { return this.searchedTransactions; }
   public void setSearchedTransactions (HashMap searchedTransactions)
      { this.searchedTransactions = searchedTransactions; }
}
