<%
/*********************************************************************************/
/* The develepment of this program is partly supported by IPA                    */
/* (Information-Technology Promotion Agency, Japan).                             */
/*********************************************************************************/

/*********************************************************************************/
/*  allTransactions.jsp                                                          */
/*  Copyright: Copyright (C) Hitachi, Ltd. 2005                                  */
/*             Author : Yoko SEKI (y-seki@sdl.hitachi.co.jp)                     */
/*  ChangeLog: (Thu Oct 06, 2005) This program lists "transactions".             */
/*            Derived from "processMethods.jsp"                                  */
/*                                                                               */
/*                                                                               */
/*  This library is free software; you can redistribute it and/or                */
/*  modify it under the terms of the GNU Lesser General Public                   */
/*  License as published by the Free Software Foundation; either                 */
/*  version 2.1 of the License, or (at your option) any later version.           */
/*                                                                               */
/*  This library is distributed in the hope that it will be useful,              */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of               */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU            */
/*  Lesser General Public License for more details.                              */
/*                                                                               */
/*  You should have received a copy of the GNU Lesser General Public             */
/*  License along with this library; if not, write to the Free Software          */
/*  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA    */
/*********************************************************************************/
%>

<%@ include file="processMenu_top.inc"%>

<%
 final int QTD_REGISTRO_PAGINA=20;
 String searchOptions = "";
 try {
  String tmpPage = request.getParameter("page");
  int paginaCorrente = 0;
  if (tmpPage!=null) {
     paginaCorrente=Integer.parseInt(tmpPage);
  }

  String order="startTime";
  if (request.getParameter("order")!=null) {
     order = request.getParameter("order");
  }

  if (request.getParameter("initial")!=null)
  {
      HashMap transactions = new HashMap();
      transactions.putAll(jbtTransactions);
      transactions.putAll(jbtiTransactions);
      beanFilter.setSearchedTransactions(transactions);
  }

  if (request.getParameter("searchRun")!=null)
  {
      HashMap transactions = new HashMap();
      JBTTransaction transaction = new JBTTransaction();

      String target="both";
      if (request.getParameter("target")!=null)
         target = request.getParameter("target");

      if      (target.equals("complete")) transactions.putAll(jbtTransactions);
      else if (target.equals("incomplete")) transactions.putAll(jbtiTransactions);
      else
      {
         transactions.putAll(jbtTransactions);
         transactions.putAll(jbtiTransactions);
      }

      JBTSearchCondition condition = new JBTSearchCondition();
      TransactionSearchEngine engine = new TransactionSearchEngine();

      boolean transactionStart = request.getParameter("tranStart")!=null;
      engine.setTransactionStart(transactionStart);
      if (transactionStart)
      {
          condition.setTranStartY1 (Integer.parseInt(request.getParameter("syyyy1")));
          condition.setTranStartM1 (Integer.parseInt(request.getParameter("sMM1")));
          condition.setTranStartD1 (Integer.parseInt(request.getParameter("sdd1")));
          condition.setTranStartHH1(Integer.parseInt(request.getParameter("shh1")));
          condition.setTranStartMM1(Integer.parseInt(request.getParameter("smm1")));
          condition.setTranStartSS1(Integer.parseInt(request.getParameter("sss1")));
          condition.setTranStartMS1(Integer.parseInt(request.getParameter("sSSS1")));

          condition.setTranStartY2 (Integer.parseInt(request.getParameter("syyyy2")));
          condition.setTranStartM2 (Integer.parseInt(request.getParameter("sMM2")));
          condition.setTranStartD2 (Integer.parseInt(request.getParameter("sdd2")));
          condition.setTranStartHH2(Integer.parseInt(request.getParameter("shh2")));
          condition.setTranStartMM2(Integer.parseInt(request.getParameter("smm2")));
          condition.setTranStartSS2(Integer.parseInt(request.getParameter("sss2")));
          condition.setTranStartMS2(Integer.parseInt(request.getParameter("sSSS2")));
      }

      boolean transactionFinish = request.getParameter("tranFinish")!=null;
      engine.setTransactionFinish(transactionFinish);
      if (transactionFinish)
      {
          condition.setTranFinishY1 (Integer.parseInt(request.getParameter("fyyyy1")));
          condition.setTranFinishM1 (Integer.parseInt(request.getParameter("fMM1")));
          condition.setTranFinishD1 (Integer.parseInt(request.getParameter("fdd1")));
          condition.setTranFinishHH1(Integer.parseInt(request.getParameter("fhh1")));
          condition.setTranFinishMM1(Integer.parseInt(request.getParameter("fmm1")));
          condition.setTranFinishSS1(Integer.parseInt(request.getParameter("fss1")));
          condition.setTranFinishMS1(Integer.parseInt(request.getParameter("fSSS1")));

          condition.setTranFinishY2 (Integer.parseInt(request.getParameter("fyyyy2")));
          condition.setTranFinishM2 (Integer.parseInt(request.getParameter("fMM2")));
          condition.setTranFinishD2 (Integer.parseInt(request.getParameter("fdd2")));
          condition.setTranFinishHH2(Integer.parseInt(request.getParameter("fhh2")));
          condition.setTranFinishMM2(Integer.parseInt(request.getParameter("fmm2")));
          condition.setTranFinishSS2(Integer.parseInt(request.getParameter("fss2")));
          condition.setTranFinishMS2(Integer.parseInt(request.getParameter("fSSS2")));
      }

      boolean methodInclude = request.getParameter("methodInc")!=null;
      engine.setMethodInclude(methodInclude);
      if (methodInclude)
      {
         engine.setIncludeAndOr(request.getParameter("methodIncAndOr"));
         condition.setIncludeMethodName(request.getParameter("methodIncName"));

         searchOptions += "&methodInclude=";
         StringTokenizer methodToken = new StringTokenizer(request.getParameter("methodIncName")," ");
         while (methodToken.hasMoreTokens())
         {
            String oneMethod = methodToken.nextToken();
            if (searchOptions.equals("&methodInclude=")) searchOptions += oneMethod;
            else searchOptions += "+" + oneMethod;
         }
      }

      boolean methodExclude = request.getParameter("methodExc")!=null;
      engine.setMethodExclude(methodExclude);
      if (methodExclude)
      {
         engine.setExcludeAndOr(request.getParameter("methodExcAndOr"));
         condition.setExcludeMethodName(request.getParameter("methodExcName"));
      }

      boolean transactionElapse = request.getParameter("tranEla")!=null;
      engine.setTransactionElapse(transactionElapse);
      if (transactionElapse)
         condition.setTransactionTime(Integer.parseInt(request.getParameter("tranTime")));

      boolean methodElapse = request.getParameter("metEla")!=null;
      engine.setMethodElapse(methodElapse);
      if (methodElapse)
      {
         condition.setMethodTime(Integer.parseInt(request.getParameter("metTime")));
         searchOptions += "&methodElapse=" + request.getParameter("metTime");
      }

      beanFilter.setSearchedTransactions
        (engine.doSearch(transactions,jbpProcess,condition));
  }

  else {
      boolean methodInclude = request.getParameter("methodInclude")!=null;
      if (methodInclude)
         searchOptions += "&methodInclude=" + request.getParameter("methodInclude");

      boolean methodElapse = request.getParameter("methodElapse")!=null;
      if (methodElapse)
         searchOptions += "&methodElapse=" + request.getParameter("methodElapse");
  }

  String sort="down";
  if (request.getParameter("sort")!=null) {
     sort = request.getParameter("sort");
  }

  String sortReverse="";
  if (sort.equals("down")) {
      sortReverse = "up";
   }
   else {
      sortReverse = "down";
   }
%>

<table class="TABELA" align=center>
   <!-- <tr  bgcolor="#dddddd" bordercolor="#666666"> -->
   <tr bgcolor="#003366" bordercolor="#666666" style="COLOR:white;">
      <td>&nbsp;</td>
      <td><a href="./allTransactions.jsp?page=<%=paginaCorrente%>&order=startTime&sort=<%=sortReverse%><%=searchOptions%>" style="color:white;">Start Time</a></td>
      <td><a href="./allTransactions.jsp?page=<%=paginaCorrente%>&order=endTime&sort=<%=sortReverse%><%=searchOptions%>" style="color:white;">End Time</td>
      <td><a href="./allTransactions.jsp?page=<%=paginaCorrente%>&order=totalTime&sort=<%=sortReverse%><%=searchOptions%>" style="color:white;">Total Time</a></td>
      <td><a href="./allTransactions.jsp?page=<%=paginaCorrente%>&order=methodsNum&sort=<%=sortReverse%><%=searchOptions%>" style="color:white;">#Methods</a></td>
      <td><a href="./allTransactions.jsp?page=<%=paginaCorrente%>&order=cpu&sort=<%=sortReverse%><%=searchOptions%>" style="color:white;">CPU</a></td>
      <td><a href="./allTransactions.jsp?page=<%=paginaCorrente%>&order=numberOfLocks&sort=<%=sortReverse%><%=searchOptions%>" style="color:white;">#Locks</a></td>
      <td><a href="./allTransactions.jsp?page=<%=paginaCorrente%>&order=lockTime&sort=<%=sortReverse%><%=searchOptions%>" style="color:white;">Lock Time</a></td>
   </tr>
   <%
      List entries;
      entries = new ArrayList(beanFilter.getSearchedTransactions().values());

      if (sort.equals("down")) SPYTransactionComparator.sort = "down";
      else                    SPYTransactionComparator.sort = "up";

      Collections.sort(entries, new SPYTransactionComparator(order));

      int inicio = paginaCorrente*QTD_REGISTRO_PAGINA;
      int fim = inicio+QTD_REGISTRO_PAGINA;

      if ( fim>=entries.size() ) {
         fim=entries.size();
      }

      for (int local=inicio;local<fim;local++) {
         JBTTransaction transaction = (JBTTransaction) entries.get(local);

	 if (local%2==0) {
          out.println("<tr bgcolor=white>");
	 } else {
          out.println("<tr bgcolor=\"#cccccc\">");
	 }
         out.println("<td><a title='Click here to view transaction methods' href=\"./transactionMethods.jsp?transactionID=" + transaction.getTransactionID() + searchOptions + "\" target=\"_blank\"><img src='./imgs/arrow.gif'></a></td>");

         long startTime = ((JBTMethod)transaction.getMethods().get(0)).getElapsedClockStart();
         long endTime   = ((JBTMethod)transaction.getMethods().get(0)).getElapsedClockEnd();

         long startCPU = ((JBTMethod)transaction.getMethods().get(0)).getClockStart();
         long endCPU   = ((JBTMethod)transaction.getMethods().get(0)).getClockEnd();

         Date date1 = new Date (startTime);
         DateFormat df = new SimpleDateFormat ("MM/dd/yyyy HH:mm:ss.SSS");
         out.println("<td>" + df.format(date1) + "</td>");

         if ( endTime!=-1)
         {
            Date date2 = new Date (endTime);
            out.println("<td>" + df.format(date2) + "</td>");
            out.println("<td>" + (long)(endTime-startTime) + "</td>");
         }
         else
         {
            out.println("<td>NOT EXIT</td>");
            out.println("<td>UNKNOWN</td>");
         }

         out.println("<td>" + (long)(transaction.getMethods().size()) + "</td>");

         if (endCPU!=-1) out.println("<td>" + (long)(endCPU-startCPU) + "</td>");
         else out.println("<td>UNKNOWN</td>");

         if (transaction.getNumberOfLocks()==0)
         {
             out.println("<td>&nbsp;</td><td>&nbsp;</td>");
         }
         else
         {
             out.println("<td>" + transaction.getNumberOfLocks() + "</td><td>" + transaction.getLockTime() + "</td>");
         }

         out.println("</tr>");
      }
   %>
</table>
<br>
<table align=center class="TABELA">
<%
  int qtdMaxPaginas=entries.size()/QTD_REGISTRO_PAGINA;
  if (entries.size()%QTD_REGISTRO_PAGINA>0) {
    qtdMaxPaginas++;
  }
%>
<tr bgcolor="#003366" bordercolor="#666666" style="COLOR:white;"><td colspan=4 align=center>Page <%=paginaCorrente%> of <%=(qtdMaxPaginas-1)%></td></tr>
<tr bgcolor="#003366" bordercolor="#666666" style="COLOR:white;">
<td><a style="COLOR:WHITE;" href="./allTransactions.jsp?page=0&order=<%=order%>&sort=<%=sort%><%=searchOptions%>">First Page </a></td>

<td>
<%

  if (paginaCorrente>0) {
     out.println("<a style=\"COLOR:WHITE;\" href=\"./allTransactions.jsp?page=" + (paginaCorrente-1) +"&order=" + order + "&sort=" + sort + searchOptions + "\">");
  }

%>
Previous
<%
  if (paginaCorrente>0) {
     out.println("</a>");
  }
%>
</td>
<td>
<%
  if ((paginaCorrente+1)<qtdMaxPaginas) {
     out.println("<a style=\"COLOR:WHITE;\" href=\"./allTransactions.jsp?page=" + (paginaCorrente+1) +"&order=" + order + "&sort=" + sort + searchOptions + "\">");
  }

%>
Next
<%
  if ((paginaCorrente+1)<qtdMaxPaginas) {
     out.println("</a>");
  }
%>
</td>
<td>
<%
out.println("<a style=\"COLOR:WHITE;\" href=\"./allTransactions.jsp?page=" + (qtdMaxPaginas-1) +"&order=" + order + "&sort=" + sort + searchOptions + "\">");
%>
Last Page
<%
out.println("</a>");
%>

</tr>
</table>
</body>
</html>
<%
   }
   catch (Exception e) {
     e.printStackTrace();
   }
%>
