<%
/*
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 
 * This file belongs to a simple implementation of a web interface for the "disconnectedProfiler".
*/
%>

<%@ include file="internalMenu.inc"%>
    <%StringBuffer buffer = new StringBuffer(); 
	java.util.Iterator iter = request.getParameterMap().keySet().iterator();
	while (iter.hasNext()) {
		Object key = iter.next();
		Object value[] = (Object[]) request.getParameterMap().get(key);
		for (int i=0;i<value.length;i++) {
			buffer.append(key.toString()+"="+java.net.URLEncoder.encode(value[i].toString()));
		}
		if (iter.hasNext()) buffer.append("&");
	}
	
	double minPercent = 0;
	if (request.getParameter("minPercent")!=null) {
	   minPercent=Double.parseDouble(request.getParameter("minPercent"));
	}
	
	int maxLevel = 0;
	if (request.getParameter("maxLevel")!=null) {
	  maxLevel=Integer.parseInt(request.getParameter("maxLevel"));
	}
	
	String urlBase = buffer.toString();
	%>
	
	<table align=center>
	<tbody>
		<%
		if (maxLevel==0 && minPercent==0) {
		%>
		<tr><td bgcolor=red> 
		  <p color=red>Warning:As you haven't selected maxLevel or minPercent you are going to have a huge file</p>
		</td></tr>
		<%
		}
		%>

		<tr><td>
			Download options:
		</td></tr>
		<tr><td>
			<a href="./xml/callings.xml?<%=urlBase%>">XML</a>
		</td></tr>
		<tr><td>
			<a href="./xml/callings.zip?<%=urlBase%>&isZip=yes">ZIP</a>
		</td></tr>
		<tr><td>
			<a href="./excel/callings.xls?<%=urlBase%>">Excel</a>
		</td></tr>
		
	</tbody>
	</table>
</body>
</html>

