<%
/*
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 
 * This file belongs to a simple implementation of a web interface for the "disconnectedProfiler".
*/
%>

<%@ include file="processMenu.inc"%>

<%
 try {
%>
<table class="TABELA" width="100%">
   <%
   
        StringBuffer parametrosBasicos = new StringBuffer();
	{
	java.util.Iterator iter = request.getParameterMap().keySet().iterator();
	while (iter.hasNext()) {
		Object key = iter.next();
		if (key.toString().equals("pathSize")) continue;
		Object value[] = (Object[]) request.getParameterMap().get(key);
		for (int i=0;i<value.length;i++) {
			parametrosBasicos.append(key.toString()+"="+java.net.URLEncoder.encode(value[i].toString()));
		}
		if (iter.hasNext()) parametrosBasicos.append("&");
	}
	}
   
      boolean viewCreation=false;
      if (request.getParameter("viewCreation")!=null) viewCreation=true;

      Integer classId = new Integer(request.getParameter("classId"));

      JBPMethod keyMethod = new JBPMethod();
      JBPClass keyClass = new JBPClass();
      keyClass.setClassID(classId.intValue());
      JBPClass JBPClass = (JBPClass)jbpProcess.getSpyClasses().get(keyClass);
      
      out.println("<br>JBPClass = " + JBPClass.getClassID());
      
      Collection listMethods = null;
      if (request.getSession().getAttribute("instancesStack.class")==null||
          !((JBPClass)session.getAttribute("instancesStack.class")).equals(JBPClass)) {
	     session.setAttribute("instancesStack.class",JBPClass);
	     listMethods = jbpProcess.findMemoryLeaks(JBPClass);
	     session.setAttribute("listMethodsLeaks",listMethods);
	  } else {
	     listMethods = (Collection)session.getAttribute("listMethodsLeaks");
	  }
      
      int pathSize = 0;
      
      if (request.getParameter("pathSize")!=null) pathSize = Integer.parseInt(request.getParameter("pathSize"));
   %>
   <table class="TABELA" width="100%">
     <TBody>
       <TR>
         <TD>
	   Methods tha keeped instances of "<%=JBPClass.getName()%>" Alive
	 </TD>
       </TR>
       
       <% 
         JBPMethodCount rootCount = null;
	 JBPMethodCount currentCount = null;
	 StringBuffer tmpURL = new StringBuffer();
	 tmpURL.append("./instancesStackGraph.jsp?classId=" + classId);
	 if (request.getParameter("viewCreation")!=null) tmpURL.append("&viewCreation="+request.getParameter("viewCreation"));
         for (int i=0;i<pathSize;i++) {
	    int methodId = Integer.parseInt(request.getParameter("m" + i));
	    keyMethod.setMethodID(methodId);
	    
	    tmpURL.append("&m" + i + "=" + methodId);

	    
	    if (i==0) {
	       Iterator iter = listMethods.iterator();
	       while (iter.hasNext()) {
	           JBPMethodCount tmpCount = (JBPMethodCount)iter.next();
		   if (tmpCount.getSpyMethod().getMethodID()==methodId) {
		      currentCount = tmpCount;
		      rootCount = tmpCount;
		   }
	       }
	    } else {
	       currentCount = currentCount.getCalledCount(keyMethod);
	    }
	    out.println("<tr><td nowrap>");
	    for (int j=0;j<=i;j++) out.print("&nbsp;&nbsp;");
	    out.println("<a href=\"" + tmpURL.toString() + "&pathSize="+ (i+1) + "\">");
	    int count=viewCreation?currentCount.getCount():currentCount.getActiveCount();
	    out.println(count + " at " + currentCount.getSpyMethod().getFullName());
	    out.println("</a");
	    out.println("</td></tr>");
	    
	 }
       %>
       
     </TBody>
   </table>

   
<br>
<APPLET CODE="org.jboss.profiler.graphapplet.GraphMemoryApplet" WIDTH=800 HEIGHT=600 ALT="Applet"
    ARCHIVE="graphApplet.jar">
<param name = "url" value="/graphMemoryServer?<%=parametrosBasicos.toString()%>&pathSize=<%=pathSize%>">

</APPLET>
     

     <table align=center>
<tr bgcolor="#003366" bordercolor="#666666" style="COLOR:white;">
   <td class="sunblue"><a style="color:white;" href="./instancesStack.jsp?<%= parametrosBasicos.toString() + "&pathSize=" + (pathSize)%>"> Regular View</a></td>
</tr>
</table>
      
   

</body>
</html>
<%
   }
   catch (Exception e) {
     e.printStackTrace();
   }
%>