<%
/*
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 
 * This file belongs to a simple implementation of a web interface for the "disconnectedProfiler".
*/
%>

<%@ include file="processMenu.inc"%>

<%
 try {
%>
<div align=center>
<table class="TABELA">

   <%
      int stateInt = Integer.parseInt(request.getParameter("state"));
      boolean orderByBytes = request.getParameter("orderByBytes")!=null;
      boolean orderByName = request.getParameter("orderByName")!=null;
    %>
   <tr  bgcolor="#003366" bordercolor="#666666" style="COLOR:white;">
      <td>&nbsp;</td>
      <td>&nbsp;</td>
      <td>&nbsp;</td>
      <td><a href="./memoryDetail.jsp?state=<%=stateInt%>&orderByName=true" style="COLOR:white;">Class</a></td>
      <td>Quantity</td>
      <td><a href="./memoryDetail.jsp?state=<%=stateInt%>&orderByBytes=true" style="COLOR:white;">Bytes</a></td>
      <td>Release Quantity</td>
      <td>Release Bytes</td>
   </tr>
   <%
      JBPMemoryState memoryState = (JBPMemoryState)jbpProcess.getMemoryStates().get(stateInt);

      TreeSet setObjects = null;

      if (orderByBytes) {
        setObjects = new TreeSet(new Comparator() {
                   public int compare (Object o1, Object o2) {
                       JBPMemoryCount s1 = (JBPMemoryCount)o1;
                       JBPMemoryCount s2 = (JBPMemoryCount)o2;
                       int retValue= s2.getSize() - s1.getSize();
                       if (retValue==0) {
                         return ((JBPClass)s1.getReferencedObject()).getName().compareTo(((JBPClass)s2.getReferencedObject()).getName());
                       } else {
                         return retValue;
                       }
                  }});
      } else {
        setObjects = new TreeSet(new Comparator() {
                   public int compare (Object o1, Object o2) {
                       JBPMemoryCount s1 = (JBPMemoryCount)o1;
                       JBPMemoryCount s2 = (JBPMemoryCount)o2;
                       return ((JBPClass)s1.getReferencedObject()).getName().compareTo(((JBPClass)s2.getReferencedObject()).getName());
                  }});
      }

      setObjects.addAll(memoryState.getInUse().values());

      Iterator iter = setObjects.iterator();

      int linha=0;
      while (iter.hasNext()) {
         JBPMemoryCount count = (JBPMemoryCount)iter.next();
	 if ((linha++)%2==0) {
          out.println("<tr bgcolor=white>");
	 } else {
          out.println("<tr bgcolor=\"#cccccc\">");
	 }
         out.println("<td nowrap> <a href=\"./instancesStack.jsp?&classId=" + ((JBPClass)count.getReferencedObject()).getClassID() +"\"> Leaks </a></td>");
         out.println("<td nowrap> <a href=\"./instancesStack.jsp?&classId=" + ((JBPClass)count.getReferencedObject()).getClassID() +"&viewCreation=true\"> Creations </a></td>");
         out.println("<td> <a href=\"./threadMemoryDetail.jsp?state="+stateInt + "&classId=" + ((JBPClass)count.getReferencedObject()).getClassID() +"\"> Threads </a></td>");
         out.println("<td nowrap=\"nowrap\">" + ((JBPClass)count.getReferencedObject()).getName() + "</td>");
         out.println("<td>" + count.getCount() + "</td>");
         out.println("<td>" + count.getSize() + "</td>");
         out.println("<td>" + count.getCountRelease() + "</td>");
         out.println("<td>" + count.getReleasedSize() + "</td>");
         out.println("</tr>");
      }
   %>
</table>
</div>
</body>
</html>
<%
   }
   catch (Exception e) {
     e.printStackTrace();
   }
%>