<%
/*
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 
 * This file belongs to a simple implementation of a web interface for the "disconnectedProfiler".
*/
%>

<%@ include file="processMenu.inc"%>

<%
 try {
%>
<div align=center>
<table class="TABELA">
   <%
      Integer methodId = new Integer(request.getParameter("methodId"));
      JBPMethod keyMethod = new JBPMethod();
      keyMethod.setMethodID(methodId.intValue());

      HashMap jbpMethods = jbpProcess.getSpyMethods();
      JBPMethod jbpMethod = (JBPMethod)jbpMethods.get(keyMethod);
      out.println("<tr bgcolor=\"#003366\" bordercolor=\"#666666\" style=\"COLOR:white;\"><td colspan=9> Methods called by " + jbpMethod.getSpyClass().getName() + "::"+ jbpMethod.getName() + "(" + jbpMethod.getSignature() + ")</tr>");
      out.println("<tr bgcolor=\"#003366\" bordercolor=\"#666666\" style=\"COLOR:white;\"><td colspan=9> Parent Method was called " + jbpMethod.getNumberOfCalls() + " times </td></tr>");

    %>
   <tr bgcolor="#003366" bordercolor="#666666" style="COLOR:white;">
      <td nowrap="nowrap">Callings</td>
      <td nowrap="nowrap">Avg Callings</td>
      <td nowrap="nowrap">Time</td>
      <td nowrap="nowrap">Avg Time</td>
      <td>Name</td>
      <td colspan=4>&nbsp;</td>
   </tr>

    <%
      TreeSet setMethods = null;

      // para ordenar pelo maior tempo
      setMethods = new TreeSet(new Comparator() {
                 public int compare (Object o1, Object o2) {
                     JBPGenericCount s1 = (JBPGenericCount)o1;
                     JBPGenericCount s2 = (JBPGenericCount)o2;
                     if ( ((JBPMethod)s1.getReferencedObject()).getName()!=null &&
                          ((JBPMethod)s2.getReferencedObject()).getName()!=null) {
                         return ((JBPMethod)s1.getReferencedObject()).getName().compareTo(((JBPMethod)s2.getReferencedObject()).getName());
                     } else {
                         return ((JBPMethod)s1.getReferencedObject()).getMethodID() - ((JBPMethod)s2.getReferencedObject()).getMethodID();
                     }
                 }});

      setMethods.addAll(jbpMethod.getSpyMethodsCallers().values());

      double totalClock = jbpProcess.getTotalClocks();

      Iterator methodsIterator = setMethods.iterator();
      int line=0;
      while (methodsIterator.hasNext()) {
         JBPGenericCount JBPGenericCount = (JBPGenericCount)methodsIterator.next();
         JBPMethod method = (JBPMethod)JBPGenericCount.getReferencedObject();
	 if ((line++)%2==0) {
          out.println("<tr bgcolor=white>");
	 } else {
          out.println("<tr bgcolor=\"#cccccc\">");
	 }
          out.println("<td>" + JBPGenericCount.getCount() + "</td>");
	 if (jbpMethod.getNumberOfCalls()>0) {
            out.println("<td>" + JBPGenericCount.getCount()/jbpMethod.getNumberOfCalls() + "</td>");
	 } else {
            out.println("<td>&nbsp;</td>");
	 }
         out.println("<td>" + (JBPGenericCount.getTotalClocks()) + "</td>");
	 if (jbpMethod.getNumberOfCalls()>0) {
            out.println("<td>" + (JBPGenericCount.getTotalClocks()/JBPGenericCount.getCount()) + "</td>");
	 } else {
            out.println("<td>&nbsp;</td>");
	 }
         String className = "undefClass";
         String methodName = "undefMethod()";
         method = (JBPMethod)jbpProcess.getSpyMethods().get(method);
         out.println("<td>" + method.getFullName() + "</td>");
         out.println("<td> <a href=\"./methodStack.jsp?methodId=" + method.getMethodID() + "\"> Detail </a></td>");
         out.println("<td> <a href=\"./methodStackCaller.jsp?methodId=" + method.getMethodID() + "\"> Callers </a></td>");
         out.println("<td> <a href=\"./stackTraceDetail.jsp?methodId=" + method.getMethodID() + "\"> StackTrace </a></td>");
         out.println("<td><a href=\"./methodsThread.jsp?methodId=" + method.getMethodID() + "\">Threads </a></td>");
         out.println("</tr>");
      }
   %>
</table>
</div>
</body>
</html>
<%
   }
   catch (Exception e) {
     e.printStackTrace();
   }
%>