<%
/*
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 
 * This file belongs to a simple implementation of a web interface for the "disconnectedProfiler".
*/
%>

<%@ include file="processMenu.inc"%>

<%
 try {
%>
<table class="TABELA" width="100%">
   <%
      Integer methodId = new Integer(request.getParameter("methodId"));
      JBPMethod keyMethod = new JBPMethod();
      keyMethod.setMethodID(methodId.intValue());
      
      Integer threadId = null;
      JBPThread thread = null;
      
      if (request.getParameter("threadId")!=null) {
         JBPThread threadKey = new JBPThread();
         threadId = new Integer(request.getParameter("threadId"));
	 threadKey.setThreadId(threadId.intValue());
	 thread=(JBPThread)jbpProcess.getSpyThreads().get(threadKey);
      }

      HashMap JBPMethods = jbpProcess.getSpyMethods();
      JBPMethod JBPMethodProcess = (JBPMethod)JBPMethods.get(keyMethod);

      JBPMethodCount consolidacao = (JBPMethodCount)request.getSession().getAttribute("consolidacaoMetodo");
       if (thread==null && (consolidacao==null || consolidacao.getSpyMethod().equals(JBPMethodProcess) || session.getAttribute("consolidacaoThread")!=null)) {
         consolidacao = jbpProcess.consolidaCallings(JBPMethodProcess);
         session.setAttribute("consolidacaoMetodo",consolidacao);
	 session.removeAttribute("consolidacaoThread");
       } else {
         JBPThread consolidacaoThread = (JBPThread)session.getAttribute("consolidacaoThread");
	 if (thread!=null && (consolidacao==null || consolidacaoThread==null || consolidacaoThread.getThreadId()!=threadId.intValue() || !consolidacao.getSpyMethod().equals(JBPMethodProcess))) {
	     consolidacao=thread.consolidaCallings(JBPMethodProcess);
             session.setAttribute("consolidacaoMetodo",consolidacao);
	     session.setAttribute("consolidacaoThread",thread);
	 }
       }
       
       // qual instancia sera utilizada no calculo
       JBPMethod JBPMethodToCalc = JBPMethodProcess;
       if (thread!=null) {
          JBPMethodToCalc=(JBPMethod)thread.getSpyMethods().get(JBPMethodToCalc);
       }


   int numberOfPaths=0;
   if (request.getParameter("npath")!=null) {
      numberOfPaths=Integer.parseInt(request.getParameter("npath"));
   }

   int methodsId[] = new int[numberOfPaths];
   JBPMethod metodosPesquisados[] = new JBPMethod[numberOfPaths];
   JBPMethodCount[] consolidacoesPesquisadas = new JBPMethodCount[numberOfPaths];

   String urlBasesrc = "methodId="+methodId ; // url para seguir o caminho
   if (thread!=null) {
     urlBasesrc+="&threadId=" + threadId;
   }
   for (int i=0;i<numberOfPaths;i++) {
      methodsId[i] = Integer.parseInt(request.getParameter("m" + i));
      urlBasesrc+="&m"+i+"="+methodsId[i];
      keyMethod.setMethodID(methodsId[i]);
      metodosPesquisados[i]=(JBPMethod)jbpProcess.getSpyMethods().get(keyMethod);
   }
   String urlBase = "./chartview?" + urlBasesrc +"&npath="+(numberOfPaths)+"&m"+numberOfPaths+"=";
   String urlBaseObjects = "./methodStackObjects.jsp?" + urlBasesrc + "&npath="+(numberOfPaths);

   for (int i=0;i<numberOfPaths;i++) {
       consolidacoesPesquisadas[i]=consolidacao.getCalledCount(metodosPesquisados[i]);
       consolidacao = consolidacoesPesquisadas[i];
   }

   JBPMethod methodConsolidado = consolidacao.getSpyMethod();
   methodConsolidado = (JBPMethod)JBPMethods.get(methodConsolidado);

   %>
   
   <%
     if (thread!=null) {
        out.println("<tr><td colspan=2>Thread&nbsp;" + thread.getName() + "</td></tr>");
     }
     out.println("<tr><td colspan=2><img src=\"./imgs/arrow.gif\">"+
        "<a href=\"./methodStack.jsp?" + urlBasesrc +"\">" +
        JBPMethodProcess.getSimplifiedName() + " = 100% calls="+ JBPMethodToCalc.getNumberOfCalls()  +"</td>");

    for (int i=0;i<numberOfPaths;i++) {
        String percentCPU="";
         if (JBPMethodToCalc.getTotalClock()!=0) {
           percentCPU=numberFormat.format(((double)consolidacoesPesquisadas[i].getTotalClocks()/(double)JBPMethodToCalc.getTotalClock())*(double)100);
         }
	 
	 String percentTime="";
         if (JBPMethodToCalc.getTotalElapsedClock()!=0) {
           percentTime=numberFormat.format(((double)consolidacoesPesquisadas[i].getTotalElapsedClock()/(double)JBPMethodToCalc.getTotalElapsedClock())*(double)100);
         }

	 
      String urlTmp="./methodStack.jsp?" + urlBasesrc +"&npath="+(i+1);
      // estabelece recuperacao da arvore
      for (int j=0;j<=i;j++) {
         urlTmp+="&m"+j+"="+metodosPesquisados[j].getMethodID();
      }
      out.print("<tr><td colspan=14>"); 
      for (int j=0;j<=i;j++) {
        out.print("&nbsp;");
      }
      out.println("<img src=\"./imgs/arrow.gif\">"+
        "<a href=\""+ urlTmp +"\">" +
        metodosPesquisados[i].getSimplifiedName()+" %CPU=" + percentCPU + "&nbsp;%Time=" + percentTime + " calls="+ consolidacoesPesquisadas[i].getCount() +"</a></td></tr>");
   }
   
   String strTree="";
   {
     StringBuffer tmp = new StringBuffer();
     for (int i=0;i<numberOfPaths;i++) {
       tmp.append("&nbsp;");
     }
   }
   %>
   <tr><td><%=strTree%></td><td><img src="<%=urlBase%>"></td></tr>
</table>

</body>
</html>
<%
   }
   catch (Exception e) {
     e.printStackTrace();
   }
%>