<%
/*
 * Distributable under LGPL license.
 * See terms of license at gnu.org.

 * This file belongs to a simple implementation of a web interface for the "disconnectedProfiler".
*/
%>

<%@ include file="processMenu.inc"%>

<%
 String allMethodsComplement="";
 final int QTD_REGISTRO_PAGINA=20;
 try {
  String tmpPage = request.getParameter("page");
  int paginaCorrente = 0;
  if (tmpPage!=null) {
     paginaCorrente=Integer.parseInt(tmpPage);
  }

  String filter="";
  if (request.getParameter("filter")!=null) {
     filter=request.getParameter("filter");
  }


  String order="cpu";
  if (request.getParameter("order")!=null) {
     order = request.getParameter("order");
  }
%>
<div align=center width="100%">
<FORM ACTION="./processMethods.jsp" METHOD=GET>
<table>
    <tr>
     <td colspan=2 align=center>
        <% if (request.getParameter("allMethods")!=null) {%>
         <a href="./processMethods.jsp?filter=<%=filter%>&page=<%=paginaCorrente%>">Roots Only</a>
	<%
	 allMethodsComplement="&allMethods=yes";
	} else {%>
         <a href="./processMethods.jsp?filter=<%=filter%>&page=<%=paginaCorrente%>&allMethods=yes">All Methods</a>
	<%
	 }%>
     </td>
    </tr>
   <tr>
     <td>
        Filter
     </td>
     <td>
        <INPUT TYPE="text" name="filter" value="<%=filter%>" class="texto">
     </td>
    <td colspan=2><input type="submit" value="Execute" class="botaoPadrao"></td>
    </tr>
</table>
</FORM>
</div>
<table class="TABELA">
   <!-- <tr  bgcolor="#dddddd" bordercolor="#666666"> -->
   <tr bgcolor="#003366" bordercolor="#666666" style="COLOR:white;">
      <td colspan=4>&nbsp;</td>
      <td><a href="./processMethods.jsp?filter=<%=filter%>&page=<%=paginaCorrente%>&order=nrLocks<%=allMethodsComplement%>" style="color:white;">#Locks</a></td>
      <td><a href="./processMethods.jsp?filter=<%=filter%>&page=<%=paginaCorrente%>&order=lock<%=allMethodsComplement%>" style="color:white;">LockTime</a></td>
      <td><a href="./processMethods.jsp?filter=<%=filter%>&page=<%=paginaCorrente%>&order=calls<%=allMethodsComplement%>" style="color:white;">Callings</a></td>
      <td><a href="./processMethods.jsp?filter=<%=filter%>&page=<%=paginaCorrente%>&order=cpu<%=allMethodsComplement%>" style="color:white;">CPU</a></td>
      <td nowrap="nowrap">Avg CPU</td>
      <td nowrap="nowrap">%CPU</td>
      <td><a href="./processMethods.jsp?filter=<%=filter%>&page=<%=paginaCorrente%>&order=time<%=allMethodsComplement%>" style="color:white;">Time</td>
      <td nowrap="nowrap">Avg Time</td>
      <td nowrap="nowrap">% Time</td>
      <td nowrap="nowrap">% Threads</td>
      <td><a href="./processMethods.jsp?filter=<%=filter%>&page=<%=paginaCorrente%>&order=methodName<%=allMethodsComplement%>" style="color:white;">Method Name</a></td>
      <td><a href="./processMethods.jsp?filter=<%=filter%>&page=<%=paginaCorrente%>&order=avgDeep<%=allMethodsComplement%>"  style="color:white;">AvgDeep</a></td>
      <td><a href="./processMethods.jsp?filter=<%=filter%>&page=<%=paginaCorrente%>&order=maxDeep<%=allMethodsComplement%>"  style="color:white;">MaxDeep</a></td>
   </tr>
   <%

      HashMap jbpMethods = jbpProcess.getSpyMethods();

      TreeSet setMethods = null;

      // para ordenar pelo maior tempo
      setMethods = new TreeSet(new SPYMethodComparator(order));

      /*Iterator iter = jbpMethods.values().iterator();
      while (iter.hasNext()) {
         JBPMethod met = (JBPMethod)iter.next();
         if ((request.getParameter("allMethods")==null && met.getjbpMethodsCallers().size()==0 || request.getParameter("allMethods")!=null)
	      && met.getNumberOfCalls()!=0 && (filter.equals("") || !filter.equals("") && met.getFullName().startsWith(filter))) {
           setMethods.add(met);
         }
      }*/

      Iterator iter = null;
      if (request.getParameter("allMethods")==null) {
          iter = jbpProcess.consolidateRoots().values().iterator();
      }
      else {
          iter = jbpMethods.values().iterator();
      }
      while (iter.hasNext()) {
         Object obj = iter.next();
	 JBPMethod met = null;
	 if (obj instanceof JBPMethod) {
            met = (JBPMethod)obj;
	 } else {
	    JBPMethodCount count = (JBPMethodCount)obj;
	    met =(JBPMethod) count.getReferencedObject();
	    met = (JBPMethod)jbpProcess.getSpyMethods().get(met);
	 }
         if (met.getNumberOfCalls()!=0 && (filter.equals("") || !filter.equals("") && met.getFullName().startsWith(filter))) {
           setMethods.add(met);
         }
      }

      //setMethods.addAll(JBPMethods.values());

      long totalClock = jbpProcess.getTotalClocks();
      if (totalClock ==0 ) totalClock=1;

      long totalElapsedClock = jbpProcess.getTotalElapsedClocks();
      if (totalElapsedClock==0) totalElapsedClock=1;

      Object arrayObj[] = setMethods.toArray();

      Iterator methodsIterator = setMethods.iterator();
      int inicio = paginaCorrente*QTD_REGISTRO_PAGINA;
      int fim = inicio+QTD_REGISTRO_PAGINA;

      if (fim>=arrayObj.length) {
         fim=arrayObj.length;
      }

      for (int local=inicio;local<fim;local++) {
         JBPMethod method = (JBPMethod)arrayObj[local];

	 if (local%2==0) {
          out.println("<tr bgcolor=white>");
	 } else {
          out.println("<tr bgcolor=\"#cccccc\">");
	 }
         out.println("<td><a title='Click here to view graph detail' href=\"./methodStack.jsp?methodId=" + method.getMethodID() + "\"><img src='./imgs/arrow.gif'></a></td>");
         out.println("<td><a href=\"./methodStackCaller.jsp?methodId=" + method.getMethodID() + "\">Callers </a></td>");
         out.println("<td><a href=\"./methodsThread.jsp?methodId=" + method.getMethodID() + "\">Threads</a></td>");
         out.println("<td><a href=\"././JBTTransaction?methodList=" + method.getMethodID() + "\">Tracing</a></td>");

         out.println("<td>" + method.getNumberOfWaits() + "</td>");
         out.println("<td>" + method.getClockInWait() + "</td>");


         out.println("<td>" + method.getNumberOfCalls() + "</td>");
         out.println("<td>" + (method.getTotalClock()) + "</td>");
         if (method.getNumberOfCalls()>0) {
           out.println("<td>" + ((method.getTotalClock()/method.getNumberOfCalls())) + "</td>");
         } else {
           out.println("<td>&nbsp</td>");
         }
         out.println("<td>" + numberFormat.format(((double)method.getTotalClock()/(double)totalClock)*100) + "</td>");

         out.println("<td>" + method.getTotalElapsedClock() + "</td>");
         if (method.getNumberOfCalls()>0) {
           out.println("<td>" + ((method.getTotalElapsedClock()/method.getNumberOfCalls())) + "</td>");
         } else {
           out.println("<td>&nbsp</td>");
         }
         out.println("<td>" + numberFormat.format(((double)method.getTotalElapsedClock()/(double)totalElapsedClock )*100) + "</td>");

         double tmpTotalElapsed=method.sumTotalElapsedTimeOnThreadList();
         if (tmpTotalElapsed!=0) {
           out.println("<td>" + numberFormat.format(((double)method.getTotalElapsedClock()/(double)tmpTotalElapsed )*100) + "</td>");
         } else {
           out.println("<td>&nbsp;</td>");
         }


         out.println("<td nowrap=\"nowrap\">" + method.getFullName() + "</td>");

         if (method.getNumberOfCalls()>0) {
          out.println("<td>" + (method.getSumDeep()/method.getNumberOfCalls()) + "</td>");
         } else {
          out.println("<td>&nbsp;</td>");
         }
         out.println("<td>" + method.getMaxDeep() + "</td>");

         out.println("</tr>");
      }
   %>
</table>
<br>
<table align=center class="TABELA">
<%
  int qtdMaxPaginas=setMethods.size()/QTD_REGISTRO_PAGINA;
  if (setMethods.size()%QTD_REGISTRO_PAGINA>0) {
    qtdMaxPaginas++;
  }
%>
<tr bgcolor="#003366" bordercolor="#666666" style="COLOR:white;"><td colspan=4 align=center>Page <%=paginaCorrente%> of <%=(qtdMaxPaginas-1)%></td></tr>
<tr bgcolor="#003366" bordercolor="#666666" style="COLOR:white;">
<td><a style="COLOR:WHITE;" href="./processMethods.jsp?filter=<%=filter%>&page=0&order=<%=order%><%=allMethodsComplement%>">First Page </a></td>
<td>
<%

  if (paginaCorrente>0) {
     out.println("<a style=\"COLOR:WHITE;\" href=\"./processMethods.jsp?filter="+filter+"&page=" + (paginaCorrente-1) +"&order=" + order + allMethodsComplement +"\">");
  }

%>
Previous
<%
  if (paginaCorrente>0) {
     out.println("</a>");
  }
%>
</td>
<td>
<%
  if ((paginaCorrente+1)<qtdMaxPaginas) {
     out.println("<a style=\"COLOR:WHITE;\" href=\"./processMethods.jsp?filter="+filter+"&page=" + (paginaCorrente+1) +"&order=" + order + allMethodsComplement + "\">");
  }

%>
Next
<%
  if ((paginaCorrente+1)<qtdMaxPaginas) {
     out.println("</a>");
  }
%>
</td>
<td>
<%
out.println("<a style=\"COLOR:WHITE;\" href=\"./processMethods.jsp?filter="+filter+"&page=" + (qtdMaxPaginas-1) +"&order=" + order + allMethodsComplement + "\">");
%>
Last Page
<%
out.println("</a>");
%>
<!-- <a style="COLOR:WHITE;"  href="./processMethods.jsp?filter="<%=filter%>"&page=<%=(qtdMaxPaginas-1)%>&order=<%=order%>">Last Page </a></td> -->
</tr>
</table>
</body>
</html>
<%
   }
   catch (Exception e) {
     e.printStackTrace();
   }
%>