<%
/*********************************************************************************/
/* The develepment of this program is partly supported by IPA                    */
/* (Information-Technology Promotion Agency, Japan).                             */
/*********************************************************************************/
                                                                                                                 
/*********************************************************************************/
/*  selectStartMethod.jsp                                                        */
/*  Copyright: Copyright (C) Hitachi, Ltd. 2005                                  */
/*             Author : Yoko SEKI (y-seki@sdl.hitachi.co.jp)                     */
/*  ChangeLog: (Thu Oct 06, 2005) This program prompts users                     */
/*            to input a method name.                                            */ 
/*            Derived from "selectpid.jsp"                                       */
/*                                                                               */
/*                                                                               */
/*  This library is free software; you can redistribute it and/or                */
/*  modify it under the terms of the GNU Lesser General Public                   */
/*  License as published by the Free Software Foundation; either                 */
/*  version 2.1 of the License, or (at your option) any later version.           */
/*                                                                               */
/*  This library is distributed in the hope that it will be useful,              */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of               */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU            */
/*  Lesser General Public License for more details.                              */
/*                                                                               */
/*  You should have received a copy of the GNU Lesser General Public             */
/*  License along with this library; if not, write to the Free Software          */
/*  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA    */
/*********************************************************************************/
%>

<%@ page import="java.util.*,org.jboss.profiler.model.*" %> 
<%@ taglib uri="/WEB-INF/struts-html.tld" prefix="html" %>
<%@ taglib uri="/WEB-INF/struts-logic.tld" prefix="logic" %>
<%@ taglib uri="/WEB-INF/struts-bean.tld" prefix="bean" %>
<%@ include file="mainMenu.inc"%>

<bean:define id="beanFilter" type="org.jboss.profiler.web.form.FilterForm" name="filterForm"/>
<bean:define id="jbpProcess" type="org.jboss.profiler.model.JBPProcess" name="filterForm" property="jbpProcess"/>
<bean:define id="searchedTransactions" type="java.util.HashMap" name="filterForm" property="searchedTransactions"/>

 <%
   beanFilter.setSearchedTransactions(new HashMap());
 %>

 <form action="./JBTTransaction" method="get" styleId="formGeral">
      <table cellpadding="2" cellspacing="2"
 style="text-align: left; width: 40%;" align="center">
        <tbody>
        <tr>
           <td bgcolor="#eeeeee" nowrap="nowrap" valign="middle" align="center" height="20">
              <b class="mdfc0b">
                 Select a method from the list below or type in any method.
              </b>
           </td>
        </tr>
        <tr>
           <td style="vertical-align: top;" nowrap align=center>
              <SELECT name="methodList" class="combo">
                 <OPTION VALUE=""></OPTION>
      <%
         Iterator iter = jbpProcess.consolidateRoots().values().iterator();
         while (iter.hasNext())
         {
            Object obj = iter.next();
            JBPMethod met = null;
            if (obj instanceof JBPMethod) {
               met = (JBPMethod) obj;
            }
            else {
               JBPMethodCount count = (JBPMethodCount) obj;
               met = (JBPMethod) count.getReferencedObject();
               met = (JBPMethod) jbpProcess.getSpyMethods().get(met);
            }

            String startMethod = met.getFullName();
            int startMethodID  = met.getMethodID();
            String simplifiedName = met.getSimplifiedName();
            if (!simplifiedName.endsWith("Exception.<init>") && 
                !simplifiedName.endsWith("Error.<init>"))
               out.println ("<OPTION VALUE=\"" + String.valueOf(startMethodID) + "\">" +
                            startMethod + "</OPTION>"); 
         }
      %>
              </SELECT>
           </td>
        </tr>
        <tr>
           <td align=center>
              OR
           </td>
        </tr>
        <tr>
         <td style="vertical-aign: top;" nowrap align=center>
         <INPUT TYPE="text" name="methodText" class="text" size="100">
         </td>
        </tr>

        <tr><td align=center>
           Show processed files
           <INPUT TYPE="checkbox" name="processedFiles" checked="checked"  class="texto">
        </td></tr>

	<tr>
	   <td align=center>
		 <INPUT TYPE="submit" name="Execute" value="Submit" class="botaoPadrao">
	   </td>
	</tr>

        </tbody>
      </table>
     </form>

</body>
</html>
