<%
/*
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 
 * This file belongs to a simple implementation of a web interface for the "disconnectedProfiler".
*/
%>

<%@ include file="processMenu.inc"%>

<%
 try {
%>
<div align=center>

   <%
      int stateInt = Integer.parseInt(request.getParameter("state"));
      int classId =  Integer.parseInt(request.getParameter("classId"));
      JBPMemoryState memoryState = (JBPMemoryState)jbpProcess.getMemoryStates().get(stateInt);
      JBPClass keyClass = new JBPClass();
      keyClass.setClassID(classId);
      JBPClass JBPClass = (JBPClass)jbpProcess.getSpyClasses().get(keyClass);

      JBPMemoryClassCount classCount =  (JBPMemoryClassCount)memoryState.getInUse().get(JBPClass);
      HashMap hashCount = classCount.getThreadCount();

   %>
   <table class="TABELA">
   <tr bgcolor="#003366" bordercolor="#666666" style="COLOR:white;">
   <%
     out.println("<td colspan=3>Thread Detail for Class " + JBPClass.getName() + " on the GC operation number " + stateInt + "</td>");
   %>
   </tr>
   <tr bgcolor="#003366" bordercolor="#666666" style="COLOR:white;">
      <td>Thread Name</td>
      <td>Quantity</td>
      <td>Bytes</td>
   </tr>

   <%

      TreeSet setObjects = null;

      // para ordenar pelo maior tempo
      setObjects = new TreeSet(new Comparator() {
                 public int compare (Object o1, Object o2) {
                     JBPMemoryCount s1 = (JBPMemoryCount)o1;
                     JBPMemoryCount s2 = (JBPMemoryCount)o2;
                     return ((JBPThread)s1.getReferencedObject()).getName().compareTo(((JBPThread)s2.getReferencedObject()).getName());
                }});

      setObjects.addAll(hashCount.values());

      Iterator iter = setObjects.iterator();

      int line=0;
      while (iter.hasNext()) {
         JBPMemoryCount count = (JBPMemoryCount)iter.next();
           if ((line++)%2==0) {
	     out.println("<tr bgcolor=white>");
           } else {
	     out.println("<tr bgcolor=\"#cccccc\">");
           }
         JBPThread JBPThread = (JBPThread)count.getReferencedObject();
         out.println("<td>" + JBPThread.getName() + "</td>");
         out.println("<td>" + count.getCount() + "</td>");
         out.println("<td>" + count.getSize() + "</td>");
         out.println("</tr>");
      }
   %>
</table>
</div>
</body>
</html>
<%
   }
   catch (Exception e) {
     e.printStackTrace();
   }
%>