<%
/*
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 
 * This file belongs to a simple implementation of a web interface for the "disconnectedProfiler".
*/
%>

<%@ include file="threadMenu.inc"%>

<%
 try {
%>
<table>
   <tr  bgcolor="#003366" bordercolor="#666666" style="COLOR:white;">
      <td>Method</td>
      <td>Callings</td>
      <td>Time</td>
      <td nowrap="nowrap">Avg time</td>
      <!--<td>Wait Miliseconds</td>
      <td>Avg Wait Time (Miliseconds)</td> -->
      <td nowrap="nowrap">% Time</td>
   </tr>
   <%
      int threadId = Integer.parseInt(request.getParameter("threadId"));
      JBPThread keyThread = new JBPThread();
      keyThread.setThreadId(threadId);
      JBPThread jbpThread = (JBPThread)jbpProcess.getSpyThreads().get(keyThread);

      TreeSet setMethods = null;

      // para ordenar pelo maior tempo
      setMethods = new TreeSet(new SPYMethodComparator("cpu"));

      setMethods.addAll(jbpThread.getSpyMethods().values());

      double totalThreadClock = jbpThread.getFinishClock() - jbpThread.getStartClock();
      Iterator methodsIterator = setMethods.iterator();
      int line=0;
      while (methodsIterator.hasNext()) {
         JBPMethod method = (JBPMethod)methodsIterator.next();
         JBPMethod methodOnProcess=(JBPMethod)jbpProcess.getSpyMethods().get(method);
	 if ((line++)%2==0) {
	     out.println("<tr bgcolor=white>");
	 } else {
	     out.println("<tr bgcolor=\"#cccccc\">");
	 }


         out.println("<td><a href=\"./methodStack.jsp?threadId="+ jbpThread.getThreadId() + "&methodId=" + methodOnProcess.getMethodID()+ "\">" + methodOnProcess.getFullName() + "</a></td>");
	 out.println("<td>" + method.getNumberOfCalls() + "</td>");
         out.println("<td>" + (method.getTotalClock()) + "</td>");
         if (method.getNumberOfCalls()>0) {
           out.println("<td>" + (method.getTotalClock()/method.getNumberOfCalls()) + "</td>");
         } else {
           out.println("<td>&nbsp</td>");
         }
         //out.println("<td>" + method.getClockInWait() + "</td>");
         //out.println("<td>" + (method.getClockInWait()/method.getNumberOfCalls()) + "</td>");
         out.println("<td>" + numberFormat.format((((double)method.getTotalClock()/(double)totalThreadClock)*100)) + "</td>");
         //out.println("<td>" + numberFormat.format((((double)(method.getTotalClock()-method.getClockInWait())/(double)totalThreadClock))*100) + "</td>");
         out.println("</tr>");
      }
   %>
</table>
</body>
</html>
<%
   }
   catch (Exception e) {
     e.printStackTrace();
   }
%>