<%
/*
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 
 * This file belongs to a simple implementation of a web interface for the "disconnectedProfiler".
*/
%>

<%@ include file="threadMenu.inc"%>

<table>
   <tr  bgcolor="#003366" bordercolor="#666666" style="COLOR:white;">
      <td>Status</td>
      <td>ID</td>
      <td>Name</td>
      <td>Start</td>
      <td>Finished</td>
      <td>Start Clock</td>
      <td>Finish Clock</td>
      <td>Total Clock</td>
      <td>&nbsp;</td>
   </tr>
   <%
      Iterator iterator = jbpProcess.getSpyThreads().values().iterator();
      String filterParameter = request.getParameter("filter");
      int line=0;
      while (iterator.hasNext()) {
         JBPThread thread = (JBPThread)iterator.next();;
         if (filterParameter!=null) {
            if (filterParameter.equals("opened") && thread.isClosed()) continue;
            if (filterParameter.equals("closed") && !thread.isClosed()) continue;
         }

	 if ((line++)%2==0) {
	     out.println("<tr bgcolor=white>");
	 } else {
	     out.println("<tr bgcolor=\"#cccccc\">");
	 }

         out.println("<td>");
	 if (!thread.isClosed()) {
	   out.println("<a href=\"./threadStackTrace.jsp?threadId=" + thread.getThreadId() + "\">");
	 }
	 out.println(thread.isClosed()?"Closed":"Opened");
	 if (!thread.isClosed()) {
	   out.println("</a>");
	 }
	 out.println(" </td>");
         out.println("<td>" + thread.getThreadId() + "</td>");
         out.println("<td>" + thread.getName() + " </td>");
         out.println("<td>" + thread.getStartTimestamp() + " </td>");
         out.println("<td>" + thread.getFinishTimestamp() + " </td>");
         out.println("<td>" + thread.getStartClock() + "</td>");
         out.println("<td>" + thread.getFinishClock() + "</td>");
         out.println("<td>" + (thread.getFinishClock()-thread.getStartClock()) + "</td>");
         out.println("<td> <a href=\"./threadMethods.jsp?threadId=" + thread.getThreadId() + "\"> Show Methods </a></td>");
         out.println("</tr>");
      }
   %>
</table>
</div>
</body>
</html>