/*
* JBoss, Home of Professional Open Source
* Copyright 2005, JBoss Inc., and individual contributors as indicated
* by the @authors tag. See the copyright.txt in the distribution for a
* full listing of individual contributors.
*
* This is free software; you can redistribute it and/or modify it
* under the terms of the GNU Lesser General Public License as
* published by the Free Software Foundation; either version 2.1 of
* the License, or (at your option) any later version.
*
* This software is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
* Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this software; if not, write to the Free
* Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
* 02110-1301 USA, or see the FSF site: http://www.fsf.org.
*/
#ifndef _DEFINE_LITE_PROFILER
#define _DEFINE_LITE_PROFILER

#include <stdlib.h>
#include <stdio.h>
#include <time.h>
#include <jvmpi.h>
#include <string.h>
#ifdef WINDOWS
	#include <windows.h>
	#include <process.h>
#else
	#include <unistd.h>
	#include <sys/time.h>
#endif

#include <signal.h>

#include <map>
#include <vector>

#include "ThreadType.h"
#include "liteProfiler.h"
#include "org_jboss_profiler_liteversion_jni_LiteVersionController.h"

void initEvents();
void debugThreads();

char ** divideStringsByCharacter(char * parameter, char characterToDive, int * numberOfResultStrings);

#endif
